//
//  ScrollMultipleWebView.m
//  vanke
//
//  Created by Z on 16/5/25.
//  Copyright © 2016年 gomore. All rights reserved.
//

#import "ScrollMultipleWebView.h"
#import <WebKit/WebKit.h>

@interface ScrollMultipleWebView ()<WKNavigationDelegate, UIScrollViewDelegate>
@property (nonatomic, strong) NSArray *arrUrls;
@property (nonatomic, strong) NSMutableArray *arrWebViews;
@property (nonatomic, strong) NSMutableArray *arrReqs;
@property (nonatomic, strong) NSMutableDictionary *dicFlag;
@property (nonatomic, strong) NSURLRequest *currentReq;
@property (nonatomic, strong) UIPageControl *pageCtrl;





@end
@implementation ScrollMultipleWebView

- (instancetype)initWithFrame:(CGRect)frame webViewUrls:(NSArray *)arrUrls
{
    self = [super initWithFrame:frame];
    if (self) {
        self.arrUrls = arrUrls;
        self.delegate = self;
        self.contentSize = CGSizeMake(arrUrls.count * frame.size.width, 0);
        self.pagingEnabled = YES;
        self.showsVerticalScrollIndicator = NO;
        CGFloat width = frame.size.width;
        CGFloat height = frame.size.height;
        for (int i = 0; i < arrUrls.count; i++) {
            
            NSString *jScript;
            if (SCREEN_WIDTH != 320) {
               jScript = @"var meta = document.createElement('meta');meta.setAttribute('name', 'viewport');meta.setAttribute('content', 'width=device-width, maximum-scale=2.0, user-scalable=no');document.getElementsByTagName('head')[0].appendChild(meta);";
            }else{
                jScript = @"var meta = document.createElement('meta');meta.setAttribute('name', 'viewport');meta.setAttribute('content', 'width=410, maximum-scale=2.0, user-scalable=no');document.getElementsByTagName('head')[0].appendChild(meta);";
            }
            WKUserScript *wkUScript = [[WKUserScript alloc] initWithSource:jScript injectionTime:WKUserScriptInjectionTimeAtDocumentEnd forMainFrameOnly:YES];
            WKUserContentController *wkUController = [[WKUserContentController alloc] init];
            [wkUController addUserScript:wkUScript];
            
            WKWebViewConfiguration *wkWebConfig = [[WKWebViewConfiguration alloc] init];
            wkWebConfig.userContentController = wkUController;
            
            WKWebView *webView = [[WKWebView alloc] initWithFrame:CGRectMake(i * frame.size.width, 0, frame.size.width, frame.size.height)
                                                    configuration:wkWebConfig
                                  ];
            NSURLRequest *request = [NSURLRequest requestWithURL:[NSURL URLWithString:arrUrls[i]]];
            [self.arrReqs addObject:request];
            [self.arrWebViews addObject:webView];
            if (i == 0){
                [webView loadRequest:request];
                self.currentReq = request;
            };
            [self addSubview:webView];

        }
        
    }
    return self;
}

- (void)setPageControlBackgroundColor:(UIColor *)bgColor
{
    self.pageCtrl = [[UIPageControl alloc] initWithFrame:CGRectMake(0, SCREEN_HEIGHT - 20, self.superview.width, 20)];
    NSLog(@"superview.width = %f, screen.width = %f", self.superview.width,SCREEN_WIDTH);
    
    self.pageCtrl.numberOfPages = self.arrUrls.count;
    self.pageCtrl.currentPage = 0;
    self.pageCtrl.currentPageIndicatorTintColor = [UIColor colorWithWhite:0.500 alpha:0.407];
    self.pageCtrl.pageIndicatorTintColor = [UIColor grayColor];
    if (bgColor) {
        self.pageCtrl.backgroundColor = bgColor;
    }
    
    [self.superview addSubview:self.pageCtrl];
}

- (void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
    NSInteger index = scrollView.contentOffset.x / SCREEN_WIDTH;
    self.pageCtrl.currentPage = index;
    NSURLRequest *req = [NSURLRequest requestWithURL:[NSURL URLWithString:self.arrUrls[index]]];
    WKWebView *webView = self.arrWebViews[index];
    self.currentReq = req;
    [webView loadRequest:req];
    
}

- (void)updateUrls:(NSArray *)arrUrls{
    self.arrUrls = arrUrls;
    
    for (int i = 0; i < arrUrls.count; i++) {
        NSURLRequest *req = self.arrReqs[i];
        if ([req isEqual:self.currentReq]) {
            WKWebView *web = self.arrWebViews[i];
            
            [web loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:arrUrls[i]]]];
        }
    }
    
}

- (NSMutableArray *)arrWebViews {
    if (!_arrWebViews) {
        _arrWebViews = [NSMutableArray array];
    }
    return _arrWebViews;
}

- (NSMutableArray *)arrReqs {
    if (!_arrReqs) {
        _arrReqs = [NSMutableArray array];
    }
    return _arrReqs;
}
- (NSMutableDictionary *)dicFlag {
    if (!_dicFlag) {
        _dicFlag = [NSMutableDictionary dictionary];
    }
    return _dicFlag;
}
- (void)webView:(WKWebView *)webView didFinishNavigation:(WKNavigation *)navigation {
    [webView sizeToFit];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
